function [max_c,q]=fast_chose_trig_atom_oomp_ml(Re,N,GT,pp,eex,option);
%
%input
%     Re  Residue of the approximation
%     N   Number of atoms in the  dictionary 
%     case 1 complex exp. 2 DCD 3 DSD 4 mix DCD \cup  DSD
%
%output
%     max_c  maximim | Re*D|
%     q indice of the atom maximazing the above 
%
L=length(Re(:,1));
M=N;
switch option
   case 1 
   cc=fft(Re,N)*sqrt(1/L);
   ac=pp*abs(cc)./(sqrt(1-GT));
   [max_c,q]=max(ac);
   case 2
   cf=fft(Re,2*M);
%
   cc=real(eex(1,:).*cf(1:M,:));
   ac=pp*abs(cc)./(sqrt(1-GT));
   [max_c,q]=max(ac);
   case 3
   cf=fft(Re,2*M);
   cf(1)=[];
   cc=-imag(eex(1,:).*cf(1:M,:));
   ac=pp*abs(cc)./(sqrt(1-GT));
   [max_c,q]=max(ac);
   case 4
   M=N/2;
   cf=fft(Re,2*M);
%   phace=eex(1,:).';
   c1(:,1)=real(eex(1,:).'.*cf(1:M,1));  
   c1(:,2)=real(eex(1,:).'.*cf(1:M,2));  
   ac1=(pp*(abs(c1)').^2)./((1-GT(:,1)).');
%   ac1=((abs(c1(:,1))'.^2) + (abs(c1(:,2))'.^2))./((1-GT(:,1)).');
%%%%%%%  ac1=((abs(c1(:,1))') + (abs(c1(:,2))'));
     cf(1,:)=[];
   c2(:,1)=-imag(eex(2,:).'.*cf(1:M,1));
   c2(:,2)=-imag(eex(2,:).'.*cf(1:M,2));
   ac2=(pp*(abs(c2)').^2)./((1-GT(:,2)).');
% 
%%%%%%%   ac2=((abs(c2(:,1))') + (abs(c2(:,2))') );
%  ac2=((abs(c2(:,1))'.^2) + (abs(c2(:,2))'.^2) )./((1-GT(:,2)).');
   [max_c1 q1]= max(((ac1)));
   [max_c2 q2]= max(((ac2)));
   if max_c1 >= max_c2 
    max_c = max_c1;
        q =q1;
   else
    max_c = max_c2;
       q=q2+N/2;
   end
   otherwise 
   disp('unknown option');
end
