%
%This script runs the TDC  to reproduce Table I in the paper
%To try a particular clip  change the value of CLIP below (From 1 to 13, for a fast run use CLIP=11)


CLIP=9;

get_settings %reads all the parametes to reproduce the table

clear cmf mf B f

[z1,z2]=size(signal);

if z1<z2 signal=signal';end

[s1,s2]=size(signal(:,1));
if s1<s2; 
 signal(:,1)=signal(:,1)'; signal(:,2)=signal(:,2)';
end
f(:,1)=signal(:,1)';
f(:,2)=signal(:,2)';
%
mul=size(f,2);

pp(1:mul)=1;
toln=5e-4;
%
s=floor(numel(f(:,1))/bw);
mf=f(1:s*bw,:);%resize the signal to be divisible by bw
Nx=numel(mf(:,1));
Nframe=Nx/bw; %number of frames
t0=1;
a=2;
icase=4;
[D nord]=get_trig_dict(bw,a,icase);
[FrameLength, N]=size(D);
clear eex
M=N;
if icase==4 M=N/2;end  %cosine \cup sin dictionary
k=1:M;
if icase==2 | icase ==4 % icase 2 cosine dictionary
eex(1,:)=exp(-pi*1i*(k-1)/(2*M))./nord(1,:);
end
if icase==3 %sine dictionary
eex(1,:)=exp(-pi*1i*(k)/(2*M))./nord(1,:);
end
if icase==4
eex(2,:)=exp(-pi*1i*(k)/(2*M))./nord(2,:);
end
%
cmf1=cell(Nframe,1);
cmf2=cell(Nframe,1);
%
for j=1:Nframe;
t=t0:t0+bw-1;
t0=t0+bw;
cmf{j}(:,1)=mf(t,1);
cmf{j}(:,2)=mf(t,2);
end
%======end the segmentation each cmf is a cell with a farme or size bw===
NBX=Nframe;
delta=1;
%
%
No=nCoe; %do not touch for now
%
%
%=============Start the approxiamtion =========
tic%
B=cmf;
[h,Di1,beta,c,Q,Nat,NorQ]=HBW_OOMPMl_Trg_FFT(B,D,tol,No,pp,eex,icase);

toc
%
%=====================================================================
clear msignal
fa1=[];
fa2=[];
for i=1:Nframe
fa1=[fa1 ; h{i}(:,1)];%get the whole signal from the frames 
fa2=[fa2 ; h{i}(:,2)];
end
nCoe=Nat;
SR= numel(mf(:,1))/nCoe% Sparsity ratio
PN=(norm(mf(:,1)-fa1)^2 + norm(mf(:,2)-fa2)^2);
SP=(norm(mf(:,1))^2+norm(mf(:,2))^2);
SNR=10*log10(SP/PN)
%
%quantize coeffeints
fprintf('After Quantization, \n')
[fac,sci,onein,cq]=quant_multi(mf,c,D,Di1,NBX,del);
%
%aritmetic code
TDC_Encoder;




