%Tesck recovery
PN=(norm(mf(:,1)-fa1)^2 + norm(mf(:,2)-fa2)^2);
SP=(norm(mf(:,1))^2+norm(mf(:,2))^2);

fprintf('SNR of the recoved signal \n');
SNR_tdc=10*log10(SP/PN)

fprintf('----------Comparison with OGG--------\n')

oggfile='TDCodec/oggfile.ogg';
audiowrite(oggfile,mf,fs,'quality',90);
[waveg,fs]=audioread(oggfile);

SNR_ogg=CalcSNRMul(mf,waveg)

fprintf('-------------------------------\n')
tdcfile='TDCodec/TDC_encoded_file.mat';

hg=dir(oggfile);
hcdt=dir(tdcfile);
tt=numel(mf)/fs/2;

OGG=hg.bytes/1000;

TDC=hcdt.bytes/1000;

tt=numel(mf)/fs/2;

OGG_bps=OGG*8/tt;
TDC_bps=TDC*8/tt;


fprintf('OGG file in KB %g.\n', OGG)
fprintf('TDC file in KB %g.\n', TDC)

fprintf('-------------------------------\n')

fprintf('OGG in kbps %g.\n', OGG_bps)
fprintf('TDC in kbps %g.\n', TDC_bps)

